@isTest
public class HOG_SAPUpdateWorkOrderActivitiesMockImpl implements WebServiceMock {

  private Boolean mockError = false;

  public HOG_SAPUpdateWorkOrderActivitiesMockImpl(Boolean mockError) {
    this.mockError = mockError;
  }

  public void doInvoke(
    Object stub,
    Object request,
    Map<String, Object> response,
    String endpoint,
    String soapAction,
    String requestName,
    String responseNS,
    String responseName,
    String responseType) {

    // Create response element from the autogenerated class.
    // Populate response element.
    // Add response element to the response parameter, as follows:
    //response.put('response_x', responseElement);
    SAPHOGWorkOrderServices.UpdateWorkOrderActivitiesResponse resp = new SAPHOGWorkOrderServices.UpdateWorkOrderActivitiesResponse();
    resp.WorkOrderActivityResponseList = new List<SAPHOGWorkOrderServices.UpdateWorkOrderActivityResponse>();

    //Create Responses per request
    SAPHOGWorkOrderServices.UpdateWorkOrderActivityRequest[] updateActivitiesRequestList = 
      ((SAPHOGWorkOrderServices.UpdateWorkOrderActivitiesRequest) request).WorkOrderActivityRequestList;
    for(SAPHOGWorkOrderServices.UpdateWorkOrderActivityRequest updateRequest : updateActivitiesRequestList) {
      SAPHOGWorkOrderServices.UpdateWorkOrderActivityResponse updateResponse = new SAPHOGWorkOrderServices.UpdateWorkOrderActivityResponse();
      updateResponse.ActivityNumber = updateRequest.ActivityNumber;
      updateResponse.ReferenceId = updateRequest.ReferenceId;
      if(mockError) {
        updateResponse.Message = 'Function BAPI_ALM_ORDER_MAINTAIN returned with type E. Status of order ' +  
          updateRequest.WorkOrderNumber + ' does not allow changes (com.mulesoft.mule.transport.sap.jco3.SapJcoException)';
        updateResponse.type_x = false;
      } else {
        updateResponse.type_x = true;
      }
      resp.WorkOrderActivityResponseList.add(updateResponse);
    }

    response.put('response_x', resp);
  }
}